#include <file.h>
#include <streams.hpp>
#pragma hdrstop
enum { tarBlkLen=0x7c };
void Error(Pchar msg);
dword oct2dword(Pchar str);

char NumBuf[6];
char HdrBuf[512];
char Buf[0x8000];
word fhTar,fhOut,_eof,Rest,ReadLen;
Pchar Pname;
dword Len;
char ProgName[]="Simple UnTar\r\n""(c)95 by Paul Sokolovsky 2:4615/9.31\r\n";

void main(int argc,char* argv[])
{
  write(ProgName,SSTRLEN(ProgName),0);
  if (argc!=3)	Error("Usage: untar x|v <tarname>\r\n"
  			"v to view, x to extract\r\n");
  if ( (fhTar=openi(argv[2]))==ERR )	Error("Cant open archive");
  while (_eof=read(HdrBuf,0x200,fhTar) AND *HdrBuf)
  {
    cout<<HdrBuf<<endl;
    Len=oct2dword(HdrBuf+tarBlkLen);
    if (*argv[1]=='x')
    {
      for (Pname=HdrBuf;*Pname;Pname++)
      {
        if (*Pname=='/')	*Pname='\\';
      }
      if (Pname[-1]=='\\')
      {
        Pname[-1]=0;
        if (!mkdir(HdrBuf))	Error("Cant create dir");
        continue;
      }
      
      if ((Rest=0x200-word(Len)&0x1ff)==0x200)	Rest=0;
      if ((fhOut=openo(HdrBuf))==ERR)	Error("Cant Open outfile");
      while (Len)
      {
        ReadLen=Len>0x8000?0x8000:Len;
        if (read(Buf,ReadLen,fhTar)!=ReadLen)	Error("Read Error");
        if (write(Buf,ReadLen,fhOut)!=ReadLen)	Error("Write Error");
        Len-=ReadLen;
      }
      close(fhOut);
      lseek(fhTar,Rest,SEEK_CUR);
    }
    else
    {
      if (word(Len)&0x1ff)	Len+=0x200;
      word(Len)&=~0x1ff;
      lseek(fhTar,Len,SEEK_CUR);
    }
  }
}

dword oct2dword(Pchar str)
{
  while (*str==' ')	str++;
  for (dword num=0;*str!=' ';str++)
  {
//    num=num*8+(*str&0x0f);
    num*=8;
    num+=*str&0x0f;
  }
  return num;
}

void Error(Pchar msg)
{
  puts(msg);
  exit(1);
}

